Bug 871892 - [tracking bug] DNF Incompatibilities with Yum
[tracking bug] DNF Incompatibilities with Yum
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: dnf (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Ales Kozumplik
Fedora Extras Quality Assurance
:
Depends On: 1055910 1182757 877449 878348 880303 880524 882851 884617 887317 889203 905209 909744 912165 916662 963710 968157 977753 988778 991038 1039324 1045383 1069538 1073457 1076045 1107973
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-31 12:23 EDT by James Antill
Modified: 2015-01-15 15:22 EST (History)
11 users (show)

See Also:
Fixed In Version: dnf-0.6.2
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-09-02 02:50:01 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description James Antill 2012-10-31 12:23:39 EDT
You said it was pretty close to compatible now, so I had a quick look. Not sure how much of these that you know about (using latest dnf in F18):



missing commands:

dnf upgrade
dnf check-update
dnf reinstall
dnf shell
dnf load-transaction
dnf version
dnf localinstall/localupdate/localupgrade
dnf groups
dnf check
dnf deplist
dnf repoinfo (a newer way to get repolist -v data)
dnf install-n/install-na/etc.
dnf remove-n/remove-na/etc.
dnf update-to
dnf distro-sync
dnf resolvedep


broken commands:

dnf repolist (no output)
dnf provides kernel (no output)
dnf update kernel (kernel is provided by kernel-PAE, probably same root problems as provides command)
dnf update /bin/cpio (causes traceback)
dnf install /bin/cpio (says "nothing provides")
dnf install /abcd (seems to run an empty transaction).
dnf history rollback /undo/redo (API for install pkgtup/etc. not implemented)
dnf makecache (doesn't seem to force recheck)
dnf --disablerepo=fedora list yum (traceback for repo. APIs).
dnf --showduplicates list yum (traceback no .verGT API on packages).
Comment 1 Ales Kozumplik 2012-11-01 04:54:17 EDT
Hi James,

Thank you for the testing, these are valid issues and I will look into them one by one.

(In reply to comment #0)
> You said it was pretty close to compatible now, so I had a quick look. 

I am not sure when I said these words? The DNF version in Fedora 18 is a preview version: I want to confirm the basic functionality of installing/updating/listing/erasing packages works and then add the Yum features back in one by one. Could you maybe, as a domain expert, try to pick the subset of the missing commands that are of highest priority?

Thanks, Ales
Comment 2 James Antill 2012-11-01 10:03:06 EDT
(In reply to comment #1)
> Hi James,
> 
> Thank you for the testing, these are valid issues and I will look into them
> one by one.
> 
> (In reply to comment #0)
> > You said it was pretty close to compatible now, so I had a quick look. 
> 
> I am not sure when I said these words? The DNF version in Fedora 18 is a
> preview version: I want to confirm the basic functionality of
> installing/updating/listing/erasing packages works and then add the Yum
> features back in one by one.

 Sure, no problem ... I thought I heard you say that yesterday in the meeting. Maybe you were saying that install/remove was basically complete? Maybe I'm just going insane? (or already gone :)

> Could you maybe, as a domain expert, try to
> pick the subset of the missing commands that are of highest priority?

 I would do these first (in roughly this order), just on the assumption that people testing it in rawhide are more likely to run these and be confused if they don't exist:

dnf upgrade (can just be a synonym for update atm.)
dnf check-update
dnf reinstall
dnf distro-sync
dnf update-to
Comment 3 Ales Kozumplik 2012-11-01 10:30:10 EDT
(In reply to comment #2)
>  Sure, no problem ... I thought I heard you say that yesterday in the
> meeting. Maybe you were saying that install/remove was basically complete?
> Maybe I'm just going insane? (or already gone :)

They are nowhere near CLI compatible yet, that is for sure:)

> 
> > Could you maybe, as a domain expert, try to
> > pick the subset of the missing commands that are of highest priority?
> 
>  I would do these first (in roughly this order), just on the assumption that
> people testing it in rawhide are more likely to run these and be confused if
> they don't exist:
> 
> dnf upgrade (can just be a synonym for update atm.)
> dnf check-update

That already works on master, bug 868810, but since there's the Beta freeze..

> dnf reinstall
> dnf distro-sync
> dnf update-to

Will start with these, thanks.
Comment 4 Ales Kozumplik 2012-11-12 08:11:21 EST
'dnf upgrade' is now an alias for 'dnf update', master commit 91a92b0, dnf-0.2.16.
Comment 5 Ales Kozumplik 2012-11-14 11:03:43 EST
'dnf reinstall' is now supported, master commit 5e0e09d, dnf-0.2.17.
Comment 6 Ales Kozumplik 2012-11-14 11:04:47 EST
> 'dnf reinstall' is now supported, master commit 5e0e09d, dnf-0.2.17.
more like dnf-0.2.16
Comment 7 Ales Kozumplik 2012-11-20 12:24:06 EST
'dnf update-to' works since commit 7dced75, dnf-0.2.17.
Comment 8 Ales Kozumplik 2012-11-26 10:00:10 EST
'dnf distro-sync' (without package-limiting arguments) works as of commit d38b9b1, dnf-0.2.17.
Comment 9 Ales Kozumplik 2012-11-27 08:08:29 EST
bug 880303 deals with the DNF not recognizing commands' arguments as provides of a package.
Comment 10 Ales Kozumplik 2012-11-27 08:11:14 EST
bug 880524 finds some discrepancies between DNF and Yum regarding kernel multiversion handling.
Comment 11 Pratyush Sahay 2012-11-30 21:21:19 EST
Comparison of trying to install an existing package:
1) yum :
$ sudo yum install stellarium
Loaded plugins: langpacks, presto, refresh-packagekit
Package stellarium-0.11.4a-1.fc18.i686 already installed and latest version
Nothing to do

2) dnf:
$ sudo dnf install stellarium
Setting up Install Process
Resolving Dependencies
--> Starting dependency resolution
--> Finished dependency resolution
Nothing to do

dnf is not informing that package is installed and hence "nothing to do".
Comment 12 Ales Kozumplik 2012-12-03 02:28:38 EST
(In reply to comment #11)
> Comparison of trying to install an existing package:
> 1) yum :
> $ sudo yum install stellarium
> Loaded plugins: langpacks, presto, refresh-packagekit
> Package stellarium-0.11.4a-1.fc18.i686 already installed and latest version
> Nothing to do
> 
> 2) dnf:
> $ sudo dnf install stellarium
> Setting up Install Process
> Resolving Dependencies
> --> Starting dependency resolution
> --> Finished dependency resolution
> Nothing to do

Hello Pratyush,

would you mind opening a new bugzilla for this? This bug is meant to summarize the major differences mentioned in comment 0 and only depend on other, newly found and perhaps less severe bugzillas.

Thanks, Ales
Comment 13 Pratyush Sahay 2012-12-03 03:50:34 EST
(In reply to comment #12)
> (In reply to comment #11)
> 
> 
> would you mind opening a new bugzilla for this? This bug is meant to
> summarize the major differences mentioned in comment 0 and only depend on
> other, newly found and perhaps less severe bugzillas.

Done.
https://bugzilla.redhat.com/show_bug.cgi?id=882851
Comment 14 Ales Kozumplik 2012-12-17 08:20:31 EST
> dnf provides kernel (no output)

fixed by commit d3d4e8d, dnf-0.2.18
Comment 15 Ales Kozumplik 2013-01-03 11:05:27 EST
excludes (bug 884617) now work (commit 28a29b4).
Comment 16 Ales Kozumplik 2013-01-07 10:15:38 EST
--skip-broken: the old yum behaviour that always tries to install the latest packages available can now be emulated in DNF with '--best' switch, bug 882211, commit 83d3338.
Comment 17 Ales Kozumplik 2013-01-14 08:03:44 EST
(In reply to comment #0)
> dnf --disablerepo=fedora list yum (traceback for repo. APIs).
> dnf --showduplicates list yum (traceback no .verGT API on packages).

These work as of commit 29d3169.
Comment 18 Fedora Update System 2013-01-18 09:57:11 EST
libsolv-0.2.3-1.gitf663ca2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libsolv-0.2.3-1.gitf663ca2.fc18
Comment 19 Ales Kozumplik 2013-01-18 11:14:00 EST
(back to assigned, this has nothing to do with the latest libsolv)
Comment 20 Pratyush Sahay 2013-01-27 02:10:59 EST
Added a bug report that compares another yum and dnf functionality:
dnf stops package install if "downloaded repomd.xml is older than what we have"
https://bugzilla.redhat.com/show_bug.cgi?id=904706
Comment 21 Fedora Update System 2013-01-29 19:56:42 EST
libsolv-0.2.3-1.gitf663ca2.fc18, hawkey-0.3.6-1.gitc8365fa.fc18, dnf-0.2.20-1.gitdec970f.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 22 Ales Kozumplik 2013-04-03 10:50:54 EDT
dnf resolvedep has been dropped: http://akozumpl.github.com/dnf/cli_vs_yum.html#no-resolvedep-command
Comment 23 Ales Kozumplik 2013-04-29 03:29:57 EDT
'dnf groups' and 'dnf group install <groupname>' work starting with dnf-0.3.4
Comment 24 Parag Nemade 2013-06-12 04:50:12 EDT
Do dnf supports plugins that yum also supports?
Comment 25 Ales Kozumplik 2013-06-18 03:19:18 EDT
(In reply to Parag from comment #24)
> Do dnf supports plugins that yum also supports?

no, there's planned plugins support but the plugins will have to be migrated.
Comment 26 Parag Nemade 2013-07-23 10:11:49 EDT
Is there any documentation available on migrating existing plugins? Is there any DNF plugin available that I can see?
Comment 27 Ales Kozumplik 2013-07-23 10:17:33 EDT
(In reply to Parag from comment #26)
> Is there any documentation available on migrating existing plugins? Is there
> any DNF plugin available that I can see?

no and nobody is working on this yet.
Comment 28 Ales Kozumplik 2013-12-04 07:44:52 EST
(In reply to Parag from comment #26)
> Is there any documentation available on migrating existing plugins? Is there
> any DNF plugin available that I can see?

https://github.com/akozumpl/dnf-plugins/blob/master/plugins/noroot.py

There's no migration document yet but the API documentation is starting to take shape:

http://akozumpl.github.io/dnf/api_plugins.html
Comment 29 Fedora End Of Life 2013-12-21 10:10:29 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 30 nicolas.vieville 2014-01-20 11:14:57 EST
Hello,

Maybe this was reported elsewhere, or it isn't the right place to do it (apologize if it is the case), but I noticed that dnf doesn't uses the includepkgs directive in repositories configuration files (.repo) as yum does. I must indicate that no other directive regarding including or excluding packages are in use in the repositories sections. 
For example, while using yum, if I add the following directive in a repository section:

enabled=1
includepkgs=dnf yum

only dnf and yum would be installed/updated/upgraded from that repository. The others packages from that repository wouldn't be taken in account.
 
While using dnf, there seems that the includepkgs directive is ignored, and all the packages from that repository are taken in account. 

What I understood about this directive with yum, is that it includes only the list packages but not all the others, while the exclude directive includes all the packages but not the listed ones. Maybe I'm wrong.

Anyway, I wanted to say that the speed that dnf is working is really impressive.

As English isn't my native language, I hope my explanation was understandable (lots of include and exclude).

Cordially,


-- 
NVieville
Comment 31 Ales Kozumplik 2014-01-21 00:36:47 EST
Hi Nicolas, we don't support includepkgs in DNF yet, but if you report it as a special bug (you can just paste your comment 30 there) we will track the request and perhaps schedule fixing it. This current bug is only a tracking bug.

Cheers, Ales
Comment 32 nicolas.vieville 2014-01-21 03:35:17 EST
(In reply to Ales Kozumplik from comment #31)
> Hi Nicolas, we don't support includepkgs in DNF yet, but if you report it as
> a special bug (you can just paste your comment 30 there) we will track the
> request and perhaps schedule fixing it. This current bug is only a tracking
> bug.

Thank you Ales for all this explanation. Sorry to not have understood that it was not the right place to report this request. As you suggest it, I opened a "special bug" wishing this feature here:

https://bugzilla.redhat.com/show_bug.cgi?id=1055910

Hope this functionality will be present in dnf final release, because using mixed repositories is sometimes mandatory (some piece of software not present in official repositories) but could be a real difficulty to maintain. Any equivalent functionality will be fine too.

Thanks again for your response.

Cordially,


-- 
NVieville
Comment 33 Ales Kozumplik 2014-09-02 02:50:01 EDT
I think we can safely close this one---with all the work over the past two years on plugins, CLI, update paths, download and crypto features etc. DNF is at the compatibility level that we consider sufficient.

Note You need to log in before you can comment on or make changes to this bug.